diff --git a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
index d6c56892b..e46da3a28 100644
--- a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
+++ b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
@@ -27,9 +27,9 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
     }
 
 	@Override
-	public boolean canThisPlantGrowOnThisBlockID(int i)
+	public boolean mayPlaceOn(int blockId)
     {
-        return i == Blocks.FARMLAND_DIRT.id;
+        return blockId == Blocks.FARMLAND_DIRT.id;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/DeadBushBlock.java b/src/main/java/net/minecraft/core/block/DeadBushBlock.java
index b22db93e1..24bdc04c0 100644
--- a/src/main/java/net/minecraft/core/block/DeadBushBlock.java
+++ b/src/main/java/net/minecraft/core/block/DeadBushBlock.java
@@ -20,9 +20,9 @@ public class DeadBushBlock extends FlowerBlock
     }
 	
     @Override
-	public boolean canThisPlantGrowOnThisBlockID(int i)
+	public boolean mayPlaceOn(int blockId)
     {
-        return i == Blocks.SAND.id || i == Blocks.DIRT_SCORCHED.id;
+        return blockId == Blocks.SAND.id || blockId == Blocks.DIRT_SCORCHED.id;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/FlowerBlock.java b/src/main/java/net/minecraft/core/block/FlowerBlock.java
index 682a27acf..d6386bddf 100644
--- a/src/main/java/net/minecraft/core/block/FlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/FlowerBlock.java
@@ -1,10 +1,7 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -15,136 +12,122 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-// Referenced classes of package net.minecraft.src:
-//            Block, Material, World, GrassBlock,
-//            AxisAlignedBB
+import java.util.Random;
 
-public class FlowerBlock extends Block implements IBonemealable
-{
+public class FlowerBlock extends Block implements IBonemealable {
+    public static final int MASK_PERMANENT = 0b1000_0000;
 
-	public boolean killedByWeather = false;
-	public boolean canBeBonemealed = false;
+    public boolean killedByWeather = false;
+    public boolean canBeBonemealed = false;
 
-	public FlowerBlock(String key, String namespaceId, int id)
-    {
+    public FlowerBlock(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.plant);
         setTicking(true);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
     }
-    
-    public FlowerBlock setKilledByWeather()
-    {
-    	killedByWeather = true;
-    	return this;
+
+    public FlowerBlock setKilledByWeather() {
+        killedByWeather = true;
+        return this;
     }
-    public FlowerBlock setBonemealable()
-    {
+
+    public FlowerBlock setBonemealable() {
         canBeBonemealed = true;
         return this;
     }
 
     @Override
     public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-    	return LeavesLayerBlock.MASK_PERMANENT;
+        return MASK_PERMANENT;
     }
-    
+
     @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
-    {
-        return super.canPlaceBlockAt(world, x, y, z) && canThisPlantGrowOnThisBlockID(world.getBlockId(x, y - 1, z));
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        return super.canPlaceBlockAt(world, x, y, z) && mayPlaceOn(world.getBlockId(x, y - 1, z));
     }
 
-    protected boolean canThisPlantGrowOnThisBlockID(int i)
-    {
-    	if (Block.blocksList[i] == null) return false;
-        return Block.blocksList[i].hasTag(BlockTags.GROWS_FLOWERS);
+    protected boolean mayPlaceOn(int blockId) {
+        if (Block.blocksList[blockId] == null) return false;
+        return Block.blocksList[blockId].hasTag(BlockTags.GROWS_FLOWERS);
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         super.onNeighborBlockChange(world, x, y, z, blockId);
-        func_268_h(world, x, y, z);
+        checkAlive(world, x, y, z);
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
-    {
-        func_268_h(world, x, y, z);
-        
-        if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && ((world.getBlockMetadata(x, y, z) & 0b1000_000) == 0) && world.getSeasonManager().getCurrentSeason().killFlowers && killedByWeather && rand.nextInt(256) == 0)
-        {
-        	world.setBlockWithNotify(x, y, z, 0);
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+        checkAlive(world, x, y, z);
+
+        if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockMetadata(x, y, z))) && world.getSeasonManager().getCurrentSeason().killFlowers && killedByWeather && rand.nextInt(256) == 0) {
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
-    protected final void func_268_h(World world, int i, int j, int k)
-    {
-        if(!canBlockStay(world, i, j, k))
-        {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-            world.setBlockWithNotify(i, j, k, 0);
+    protected final void checkAlive(World world, int x, int y, int z) {
+        if (!canBlockStay(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
     @Override
-    public boolean canBlockStay(World world, int x, int y, int z)
-    {
-        return (world.getFullBlockLightValue(x, y, z) >= 8 || world.canBlockSeeTheSky(x, y, z)) && canThisPlantGrowOnThisBlockID(world.getBlockId(x, y - 1, z));
+    public boolean canBlockStay(World world, int x, int y, int z) {
+        return (world.getFullBlockLightValue(x, y, z) >= 8 || world.canBlockSeeTheSky(x, y, z)) && mayPlaceOn(world.getBlockId(x, y - 1, z));
+    }
+
+    public static boolean isPermanent(int metadata) {
+        return (metadata & MASK_PERMANENT) > 0;
+    }
+
+    public static int setPermanent(int metadata, boolean permanent) {
+        return (metadata & ~MASK_PERMANENT) | (permanent ? MASK_PERMANENT : 0b0000_0000);
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         Random rand = world.rand;
-        if(!world.isClientSide && canBeBonemealed)
-        {
-            if (entityplayer.getGamemode().consumeBlocks())
-            {
+        if (!world.isClientSide && canBeBonemealed) {
+            if (entityplayer.getGamemode().consumeBlocks()) {
                 itemstack.stackSize--;
             }
             label0:
-            for(int j1 = 0; j1 < 128; j1++)
-            {
+            for (int j1 = 0; j1 < 128; j1++) {
                 int k1 = blockX;
                 int l1 = blockY;
                 int i2 = blockZ;
-                for(int j2 = 0; j2 < j1 / 16; j2++)
-                {
+                for (int j2 = 0; j2 < j1 / 16; j2++) {
                     k1 += rand.nextInt(3) - 1;
                     l1 += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
                     i2 += rand.nextInt(3) - 1;
                     int id1 = world.getBlockId(k1, l1 - 1, i2);
-                    if(Block.blocksList[id1] == null || !Block.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS))
-                    {
+                    if (Block.blocksList[id1] == null || !Block.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS)) {
                         continue label0;
                     }
                 }
 
-                if(world.getBlockId(k1, l1, i2) != 0)
-                {
+                if (world.getBlockId(k1, l1, i2) != 0) {
                     continue;
                 }
-                if(rand.nextFloat() > 0.75)
-                {
+                if (rand.nextFloat() > 0.75) {
                     world.setBlockWithNotify(k1, l1, i2, id);
                 }
             }
diff --git a/src/main/java/net/minecraft/core/block/JarBlock.java b/src/main/java/net/minecraft/core/block/JarBlock.java
index 4b66b37a5..63f6e3293 100644
--- a/src/main/java/net/minecraft/core/block/JarBlock.java
+++ b/src/main/java/net/minecraft/core/block/JarBlock.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.entity.FlowerJarBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -78,22 +79,40 @@ public class JarBlock extends EntityBlock {
             } else {
                 FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
                 int flowerInPot = tileEntity.flowerInPot;
+                int flowerData = tileEntity.flowerData;
                 if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
                     tileEntity.flowerInPot = 0;
                     world.setBlockMetadataWithNotify(x, y, z, 0);
                     world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
                     if (!world.isClientSide) {
-                        world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, 0));
+                        world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, flowerData));
                     }
                 }
             }
-        } else if (world.getBlockMetadata(x, y, z) == 0 && player.getHeldItem().getItem() instanceof BlockItem) {
+        } else if (player.getHeldItem().getItem() instanceof BlockItem) {
             Block blockInHand = ((BlockItem) player.getHeldItem().getItem()).getBlock();
-            if(hasTag(blockInHand.id, BlockTags.PLANTABLE_IN_JAR)){
-                player.getHeldItem().consumeItem(player);
+            if (hasTag(blockInHand.id, BlockTags.PLANTABLE_IN_JAR)) {
                 FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
-                world.setBlockMetadataWithNotify(x, y, z, 1);
-                tileEntity.flowerInPot = blockInHand.id;
+                if(world.getBlockMetadata(x, y, z) == 0) {
+                    player.getHeldItem().consumeItem(player);
+                    world.setBlockMetadataWithNotify(x, y, z, 1);
+                    tileEntity.flowerInPot = blockInHand.id;
+                    tileEntity.flowerData = player.getHeldItem().getMetadata();
+                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+                    return true;
+                } else if (blockInHand instanceof StackedFlowerBlock && blockInHand == Block.getBlock(tileEntity.flowerInPot)) {
+                    final int metadata = tileEntity.flowerData;
+                    final int currentStackCount = StackedFlowerBlock.getStackCount(metadata);
+                    if (currentStackCount >= StackedFlowerBlock.MAX_STACK_COUNT) {
+                        return false;
+                    }
+
+                    final int newMetadata = StackedFlowerBlock.setPermanent(StackedFlowerBlock.setStackCount(metadata, currentStackCount + 1), true);
+                    tileEntity.flowerData = newMetadata;
+                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+                    player.getHeldItem().consumeItem(player);
+                    return true;
+                }
             }
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/block/MushroomBlock.java b/src/main/java/net/minecraft/core/block/MushroomBlock.java
index a3a06e182..f14f9b8ad 100644
--- a/src/main/java/net/minecraft/core/block/MushroomBlock.java
+++ b/src/main/java/net/minecraft/core/block/MushroomBlock.java
@@ -39,9 +39,9 @@ public class MushroomBlock extends FlowerBlock
     }
 
     @Override
-	protected boolean canThisPlantGrowOnThisBlockID(int i)
+	protected boolean mayPlaceOn(int blockId)
     {
-        return Block.solid[i];
+        return Block.solid[blockId];
     }
 
     @Override
@@ -52,7 +52,7 @@ public class MushroomBlock extends FlowerBlock
             return false;
         } else
         {
-            return world.getFullBlockLightValue(x, y, z) < 13 && canThisPlantGrowOnThisBlockID(world.getBlockId(x, y - 1, z));
+            return world.getFullBlockLightValue(x, y, z) < 13 && mayPlaceOn(world.getBlockId(x, y - 1, z));
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
index a2af4d4e2..13e3af427 100644
--- a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
@@ -25,9 +25,9 @@ public abstract class SaplingBaseBlock extends FlowerBlock implements IBonemeala
     }
 
 	@Override
-	public boolean canThisPlantGrowOnThisBlockID(int i)
+	public boolean mayPlaceOn(int blockId)
     {
-        return i == Blocks.SAND.id || super.canThisPlantGrowOnThisBlockID(i);
+        return blockId == Blocks.SAND.id || super.mayPlaceOn(blockId);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/SeatBlock.java b/src/main/java/net/minecraft/core/block/SeatBlock.java
index fd1d63380..52dabc50c 100644
--- a/src/main/java/net/minecraft/core/block/SeatBlock.java
+++ b/src/main/java/net/minecraft/core/block/SeatBlock.java
@@ -57,7 +57,7 @@ public class SeatBlock
     
     @Override
     protected BlockEntity getNewBlockEntity() {
-        return new SeatBlockEntity();
+        return new SeatBlockEntity(this);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java b/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
new file mode 100644
index 000000000..313f005cc
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
@@ -0,0 +1,69 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+/**
+ * Represents a flower block that can store multiple flowers within itself, up to a maximum of 4.
+ */
+public class StackedFlowerBlock extends FlowerBlock {
+    public static final int MASK_STACK_COUNT = 0b0110_0000;
+    public static final int OFFSET_STACK_COUNT = 5;
+    public static final int MAX_STACK_COUNT = MASK_STACK_COUNT >> OFFSET_STACK_COUNT;
+
+    public StackedFlowerBlock(String key, String namespaceId, int id) {
+        super(key, namespaceId, id);
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+        final int metadata = stack.getMetadata();
+        return setPermanent(metadata, true);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
+        final int stackCount = getStackCount(meta) + 1;
+
+        if (dropCause == EnumDropCause.PICK_BLOCK) {
+            return new ItemStack[] { new ItemStack(this, 1, 0) };
+        } else if (dropCause == EnumDropCause.SILK_TOUCH) {
+            return new ItemStack[] { new ItemStack(this, 1, meta & MASK_STACK_COUNT)};
+        } else {
+            return new ItemStack[] { new ItemStack(this, stackCount, 0) };
+        }
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        final int metadata = world.getBlockMetadata(x, y, z);
+        final int currentStackCount = getStackCount(metadata);
+        if (currentStackCount >= MAX_STACK_COUNT) {
+            return false;
+        }
+
+        final ItemStack heldItem = player.getHeldItem();
+        if (heldItem == null || heldItem.stackSize < 1 || heldItem.getItem().id != this.id) {
+            return false;
+        }
+
+        final int newMetadata = setPermanent(setStackCount(metadata, currentStackCount + 1), true);
+        world.setBlockMetadataWithNotify(x, y, z, newMetadata);
+        world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+        heldItem.consumeItem(player);
+        return true;
+    }
+
+    public static int getStackCount(int metadata) {
+        return (metadata & MASK_STACK_COUNT) >> OFFSET_STACK_COUNT;
+    }
+
+    public static int setStackCount(int metadata, int stackCount) {
+        return (metadata & ~MASK_STACK_COUNT) | ((stackCount << OFFSET_STACK_COUNT) & MASK_STACK_COUNT);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/SteelFenceBlock.java b/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
index 2f554c0a6..3dba8a56f 100644
--- a/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/SteelFenceBlock.java
@@ -12,6 +12,6 @@ public class SteelFenceBlock extends ThinFenceBlock {
     @Override
     public boolean canConnectTo(WorldSource world, int x, int y, int z) {
         int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial == Material.stone || Block.blocksList[id].blockMaterial == Material.metal));
+        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Block.blocksList[id] != null && (Block.blocksList[id].blockMaterial.isStone() || Block.blocksList[id].blockMaterial == Material.metal));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/TallGrassBlock.java b/src/main/java/net/minecraft/core/block/TallGrassBlock.java
index 860bfff67..be059352c 100644
--- a/src/main/java/net/minecraft/core/block/TallGrassBlock.java
+++ b/src/main/java/net/minecraft/core/block/TallGrassBlock.java
@@ -22,12 +22,12 @@ public class TallGrassBlock extends FlowerBlock
     }
 
     @Override
-    protected boolean canThisPlantGrowOnThisBlockID(int i) {
-    	Block block = Block.getBlock(i);
+    protected boolean mayPlaceOn(int blockId) {
+    	Block block = Block.getBlock(blockId);
     	if(block != null && block instanceof MossBlock) {
     		return true;
     	}
-    	return super.canThisPlantGrowOnThisBlockID(i);
+    	return super.mayPlaceOn(blockId);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
index 5b6b34e58..f19d28083 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
@@ -146,7 +146,7 @@ public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
         if (worldObj != null) {
             BlastFurnaceBlock.updateFurnaceBlockState(forceLit | (currentBurnTime > 0), worldObj, x, y, z);
         } else if (carriedBlock != null) {
-            carriedBlock.block = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE : Blocks.FURNACE_BLAST_IDLE;
+            carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE.id : Blocks.FURNACE_BLAST_IDLE.id;
         }
     }
 
